/* A Bison parser, made by GNU Bison 2.4.570-7a582.  */

/* Skeleton interface for Bison LALR(1) parsers in C++

   Copyright (C) 2002-2011 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C++ LALR(1) parser skeleton written by Akim Demaille.  */

#ifndef PARSER_HEADER_H
# define PARSER_HEADER_H




#include <stdexcept>
#include <string>
#include <iostream>
#include "stack.hh"
#include "location.hh"



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


namespace yy {
/* Line 178 of lalr1.cc  */
#line 71 "asm-parse.hh"

  /// A Bison parser.
  class parser
  {
  public:
#ifndef YYSTYPE
    /// Symbol semantic values.
    union semantic_type
    {/* Line 184 of lalr1.cc  */
#line 56 "asm-parse.yy"

  int			i;
  std::string		*s;
  misc::unique_string	*id;
  inst::Label           *label;
  inst::Register        *reg;
  inst::Exp             *exp;


/* Line 184 of lalr1.cc  */
#line 92 "asm-parse.hh"
    };
#else
    typedef YYSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef location location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m);
      location_type location;
    };

    /// Tokens.
    struct token
    {
      /* Tokens.  */
   enum yytokentype {
     YYEOF = 0,
     LABEL = 258,
     LABEL_DEF = 259,
     INTEGER = 260,
     STRING = 261,
     REGISTER = 262,
     LPAREN = 263,
     RPAREN = 264,
     COMMA = 265,
     EXP_SUB = 266,
     EXP_ADD = 267,
     EXP_DIV = 268,
     EXP_MUL = 269,
     EXP_UMINUS = 270,
     DIR_TEXT = 271,
     DIR_DATA = 272,
     DIR_SPACE = 273,
     DIR_BYTE = 274,
     DIR_HALF = 275,
     DIR_WORD = 276,
     DIR_ASCII = 277,
     DIR_ASCIIZ = 278,
     ADD = 279,
     ADDU = 280,
     ADDI = 281,
     ADDIU = 282,
     SUB = 283,
     SUBU = 284,
     NEG = 285,
     NEGU = 286,
     ABS = 287,
     MUL = 288,
     DIV = 289,
     DIVU = 290,
     REM = 291,
     REMU = 292,
     SLL = 293,
     SLLV = 294,
     SRA = 295,
     SRAV = 296,
     SRL = 297,
     SRLV = 298,
     ROL = 299,
     ROR = 300,
     AND = 301,
     ANDI = 302,
     OR = 303,
     ORI = 304,
     XOR = 305,
     XORI = 306,
     NOR = 307,
     NOT = 308,
     SEQ = 309,
     SNE = 310,
     SGE = 311,
     SGEU = 312,
     SGT = 313,
     SGTU = 314,
     SLE = 315,
     SLEU = 316,
     SLT = 317,
     SLTU = 318,
     SLTI = 319,
     SLTIU = 320,
     BEQ = 321,
     BEQZ = 322,
     BNE = 323,
     BNEZ = 324,
     BGE = 325,
     BGEU = 326,
     BGEZ = 327,
     BGEZAL = 328,
     BGT = 329,
     BGTU = 330,
     BGTZ = 331,
     BLE = 332,
     BLEU = 333,
     BLEZ = 334,
     BLT = 335,
     BLTU = 336,
     BLTZ = 337,
     BLTZAL = 338,
     J = 339,
     JAL = 340,
     JR = 341,
     JALR = 342,
     LB = 343,
     LBU = 344,
     LW = 345,
     LUI = 346,
     LI = 347,
     LA = 348,
     SB = 349,
     SW = 350,
     MOVE = 351,
     MFHI = 352,
     MFLO = 353,
     MTHI = 354,
     MTLO = 355,
     MFC0 = 356,
     MTC0 = 357,
     SYSCALL = 358,
     NOP = 359
   };

    };

    /// Token type.
    typedef token::yytokentype token_type;

    /// A complete symbol, with its type.
    template <typename Exact>
    struct symbol_base_type
    {
      /// Default constructor.
      inline symbol_base_type ();

      /// Constructor.
      inline symbol_base_type (const location_type& l);
      inline symbol_base_type (const semantic_type& v, const location_type& l);

      /// Return this with its exact type.
      const Exact& self () const;
      Exact& self ();

      /// Return the type of this symbol.
      int type_get () const;

      /// The semantic value.
      semantic_type value;

      /// The location.
      location_type location;
    };

    /// External form of a symbol: its type and attributes.
    struct symbol_type : symbol_base_type<symbol_type>
    {
      /// The parent class.
      typedef symbol_base_type<symbol_type> super_type;

      /// Default constructor.
      inline symbol_type ();

      /// Destructive move, \a s is emptied.
      inline void move (symbol_type& s);

      /// Constructor for tokens with semantic value.
      inline symbol_type (token_type t, const semantic_type& v, const location_type& l);

      /// Constructor for valueless tokens.
      inline symbol_type (token_type t, const location_type& l);

      /// The symbol type.
      int type;

      /// The symbol type.
      inline int type_get_ () const;

      /// The token.
      inline token_type token () const;
    };

    /// Build a parser object.
    parser (std::string &filename_yyarg, inst::ProgramBuilder &program_builder_yyarg);
    virtual ~parser ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

  private:
    /// State numbers.
    typedef int state_type;

    /// Generate an error message.
    /// \param yystate   the state where the error occurred.
    /// \param yytoken   the lookahead token.
    virtual std::string yysyntax_error_ (state_type yystate, int yytoken);

    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yylhs     the nonterminal to push on the stack
    state_type yy_lr_goto_state_ (state_type yystate, int yylhs);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue);

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue);

    /// Internal symbol numbers.
    typedef unsigned char token_number_type;
    static const signed char yypact_ninf_;
    static const signed char yytable_ninf_;

    /* Tables.  */
  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.    */
  static const short int yypact_[];

  /* YYDEFACT[S] -- default reduction number in state S.  Performed when
     YYTABLE does not specify something else to do.  Zero means the default
     is an error.    */
  static const unsigned char yydefact_[];

  /* YYPGOTO[NTERM-NUM].    */
  static const signed char yypgoto_[];

  /* YYDEFGOTO[NTERM-NUM].    */
  static const short int yydefgoto_[];

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If YYTABLE_NINF, syntax error.    */
  static const unsigned short int yytable_[];

  static const short int yycheck_[];

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.    */
  static const unsigned char yystos_[];

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.    */
  static const unsigned char yyr1_[];

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.    */
  static const unsigned char yyr2_[];


#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
    /// For a symbol, its name in clear.
    static const char* const yytname_[];
#endif

    /// Convert the symbol name \a n to a form suitable for a diagnostic.
    static std::string yytnamerr_ (const char *n);

#if YYDEBUG
  /* YYRLINEYYN -- Source line where rule number YYN was defined.    */
  static const unsigned short int yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r);
    /// Print the state stack on the debug stream.
    virtual void yystack_print_ ();

    /* Debugging.  */
    int yydebug_;
    std::ostream* yycdebug_;
#endif

    /// Convert a scanner token number \a t to a symbol number.
    static inline token_number_type yytranslate_ (int t);

#if YYDEBUG
    /// \brief Display a symbol type, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Exact>
    void yy_print_ (std::ostream& yyo,
                    const symbol_base_type<Exact>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param s         The symbol.
    template <typename Exact>
    inline void yy_destroy_ (const char* yymsg,
                             symbol_base_type<Exact>& yysym) const;

  private:
    /// Element of the stack: a state and its attributes.
    struct stack_symbol_type : symbol_base_type<stack_symbol_type>
    {
      /// The parent class.
      typedef symbol_base_type<stack_symbol_type> super_type;

      /// Default constructor.
      inline stack_symbol_type ();

      /// Constructor.
      inline stack_symbol_type (state_type s, const semantic_type& v, const location_type& l);

      /// The state.
      state_type state;

      /// The type (corresponding to \a state).
      inline int type_get_ () const;
    };

    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the symbol
    /// \warning the contents of \a s.value is stolen.
    inline void yypush_ (const char* m, stack_symbol_type& s);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a s.value is stolen.
    inline void yypush_ (const char* m, state_type s, symbol_type& sym);

    /// Pop \a n symbols the three stacks.
    inline void yypop_ (unsigned int n = 1);

    /* Constants.  */
    enum
    {
      yyeof_ = 0,
      yylast_ = 921,           //< Last index in yytable_.
      yynnts_ = 7,  //< Number of nonterminal symbols.
      yyempty_ = -2,
      yyfinal_ = 2, //< Termination state number.
      yyterror_ = 1,
      yyerrcode_ = 256,
      yyntokens_ = 105,   //< Number of tokens.
    };


    /* User arguments.  */
    std::string &filename;
    inst::ProgramBuilder &program_builder;
  };



} // yy
/* Line 347 of lalr1.cc  */
#line 471 "asm-parse.hh"





#endif /* ! defined PARSER_HEADER_H */
